//
//  Simulation.m
//  Evolution
//
//  Created by Ivo Npflin.
//  Copyright (c) 2004 evo.naepflin.com. All rights reserved.
//

#import "Simulation.h"
#import "Controller.h"
#import "Tier.h"
#import "Feld.h"

@implementation Simulation

NSMutableArray *Tiere; 
NSMutableArray *Felder; 
BOOL prozessLauf;
int AnzahlFelderX;
int AnzahlFelderY;
int Rand;
int r, s, t, u, v, w, i, z;
int ProzessZaehler;
//Steuerfunktionen
- (id)init
{
	Tiere = [[NSMutableArray alloc] init];
	//Tiere = [Tiere retain];
	Felder = [[NSMutableArray alloc] init];
	int ProzessZaehler = 0;
			
			// Felder erstellen
	AnzahlFelderX = 10;	//Feldgrsse
	AnzahlFelderY = 10;
	AnzahlFelderX--;
	AnzahlFelderY--;
	

	for (r = 0; r <= AnzahlFelderX; r++)
	{
		NSMutableArray *Reihe = [[NSMutableArray alloc] init];
		for (s = 0; s <= AnzahlFelderY; s++)
			{
				if (r == 0 || r == AnzahlFelderX || s == 0 || s == AnzahlFelderY)
				{
					[Reihe addObject:[[Feld alloc] initAmRand:YES]];
				}
				else
				{
					[Reihe addObject:[[Feld alloc] initAmRand:NO]];
				}
			}
		[Felder addObject:Reihe];
		[Reihe release];
	}
	return self;
} 

- (id)starten:(id)sender
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	srand([[NSDate date] timeIntervalSince1970]);   //fr zufllige Zufallswerte ntig
	rand(); rand(); rand();
	prozessLauf = YES;
		
	
											//Prozess
	while (prozessLauf)
	{
		//Alle Tiere bewegen
		for (z = 0; z < [Tiere count]; z++)
		{
			[self ZugController:z];
			//Statistiken sollen hier noch gemacht werden.
		}
		
		//Alle Felder wachsen
		
		for (t = 0; t < AnzahlFelderX; t++)
		{
			NSMutableArray *Reihe;
			Reihe = [Felder objectAtIndex:t];

			for (u = 0; u < AnzahlFelderY; u++)
				{
					[[Reihe objectAtIndex:u] Wachsen];
				}
		}
		
		if ([Tiere count] == 0)		//falls alle gestorben sind Simulation stoppen 
		{
			[myController Stop:self];
		}
	
		ProzessZaehler++;

	}
	
	[pool release];
	
	return self;
}

- (id)anzeigen:(id)sender
{
	return self;
}

- (id)stoppen:(id)sender
{
	prozessLauf = NO;
	return self;
}


//Prozessfunktionen
- (id)ZugController:(int)TierID
{
	id gewaehltesTier = [Tiere objectAtIndex:TierID];
	int StandortX = [gewaehltesTier StandortX];
	int StandortY = [gewaehltesTier StandortY];
	
	[gewaehltesTier Altern];
			//Energie fr Leben
	[gewaehltesTier Energieabnahme:1/20*[gewaehltesTier Groesse]];

	if([gewaehltesTier Energiestand] < 0 || [gewaehltesTier Alter] > 100)
	{
			//sterben
		[self TierStirbt:[Tiere objectAtIndex:TierID] an:1];
	}
	else
	{
			//Entscheidungsprozess wird eingeleitet
		[self EntscheidungTier:gewaehltesTier];
	}
	
	return self;
}

- (void)TiereAussetzenSim:(int)Anzahl
{
	int v;
	for (v = 0; v < Anzahl; v++)
	{
		[Tiere addObject:[[Tier alloc] initMitVater:nil Mutter:nil]];
	}
}



//Abfragefunktionen
- (int)AnzahlTiere
{
	return [Tiere count];
}
- (id)TierMitID:(int)ID
{
	return [Tiere objectAtIndex:ID];
}
- (int)ProzessZaehler
{
	return ProzessZaehler;
}


//Prozesshilfsfunktionen
- (id)EntscheidungTier:(id)gewaehltesTier
{
	int StandortX = [gewaehltesTier StandortX];
	int StandortY = [gewaehltesTier StandortY];
	
	int TierID = [Tiere indexOfObjectIdenticalTo:gewaehltesTier];

	id zweitesTier = nil;
	
	int PunkteFuerTatUndZug[4][9];
	
	id moeglichesFeld[9];
	int Gesamtpunktzahl = 0;
	
	moeglichesFeld[0] = [[Felder objectAtIndex:StandortX-1] objectAtIndex:StandortY-1];
	moeglichesFeld[1] = [[Felder objectAtIndex:StandortX-1] objectAtIndex:StandortY+0];
	moeglichesFeld[2] = [[Felder objectAtIndex:StandortX-1] objectAtIndex:StandortY+1];
	moeglichesFeld[3] = [[Felder objectAtIndex:StandortX+0] objectAtIndex:StandortY-1];
	moeglichesFeld[4] = [[Felder objectAtIndex:StandortX+0] objectAtIndex:StandortY+0];
	moeglichesFeld[5] = [[Felder objectAtIndex:StandortX+0] objectAtIndex:StandortY+1];
	moeglichesFeld[6] = [[Felder objectAtIndex:StandortX+1] objectAtIndex:StandortY-1];
	moeglichesFeld[7] = [[Felder objectAtIndex:StandortX+1] objectAtIndex:StandortY+0];
	moeglichesFeld[8] = [[Felder objectAtIndex:StandortX+1] objectAtIndex:StandortY+1];

			//Attraktivitt der verschiedenen Felder ermitteln
	int WeideParameter = [gewaehltesTier WeideParameter];
	int KampfParameter = [gewaehltesTier KampfParameter];
	int KampfParameterEigeneArt = [gewaehltesTier KampfParameterEigeneArt];
	int FortpflanzungsParameter = [gewaehltesTier FortpflanzungsParameter];
	int FortpflanzungsParameterEigeneArt = [gewaehltesTier FortpflanzungsParameterEigeneArt];
	int WartenParameter = [gewaehltesTier WartenParameter];
	int StehenBleibenBonus = [gewaehltesTier StehenBleibenBonus];
	
	
	for (v = 0; v < 9; v++)
	{
		zweitesTier = [moeglichesFeld[v] getTier];
		if (zweitesTier != nil && zweitesTier != gewaehltesTier)
		{
			if ([gewaehltesTier Groesse]+2 > [zweitesTier Groesse] && [gewaehltesTier Groesse]-2 < [zweitesTier Groesse])
			{
					//Fortpflanzung
				PunkteFuerTatUndZug[0][v] = FortpflanzungsParameterEigeneArt;
		
					//Kampf
				PunkteFuerTatUndZug[1][v] = KampfParameterEigeneArt;
			}
			else
			{
					//Fortpflanzung
				PunkteFuerTatUndZug[0][v] = FortpflanzungsParameter;
		
					//Kampf
				PunkteFuerTatUndZug[1][v] = KampfParameter;
			}
		}
		else
		{
				PunkteFuerTatUndZug[0][v] = 0;
				PunkteFuerTatUndZug[1][v] = 0;
		}
		
			//Weiden
		PunkteFuerTatUndZug[2][v] = [moeglichesFeld[v] WeideAnziehung] * WeideParameter;
		
			//Warten
		PunkteFuerTatUndZug[3][v] = WartenParameter;		
	}
	
		//Bonus fr Stehenbleiben verteilen
	for (v = 0; v < 4; v++)
	{
		PunkteFuerTatUndZug[v][4] = PunkteFuerTatUndZug[v][4] + StehenBleibenBonus;
	}
	
		//Gesamtpunktzahl berechnen
	for (v = 0; v < 9; v++)
	{
		for (w = 0; w < 4; w++)
		{
			Gesamtpunktzahl = Gesamtpunktzahl + PunkteFuerTatUndZug[w][v];
		}
	}

		//Wahl treffen
	if (Gesamtpunktzahl > 0)
	{
		Rand = Gesamtpunktzahl * ((float)rand() / RAND_MAX);
		int bisherigePunkte = 0;
		int GesamtpunkteFuerZug[9];
		
			//Gesamtpunktzahlen fr die einzelnen Zge berechnen
		for (v = 0; v < 9 ; v++)
		{
			GesamtpunkteFuerZug[v] = PunkteFuerTatUndZug[1][v] + PunkteFuerTatUndZug[1][v] + PunkteFuerTatUndZug[2][v] + PunkteFuerTatUndZug[3][v];
		}
		
		
			//Wahl zufllig ermitteln
		if (Rand < GesamtpunkteFuerZug[0])
		{
			Rand = GesamtpunkteFuerZug[0] * ((float)rand() / RAND_MAX);
			int TatID = 4;
			if (Rand < PunkteFuerTatUndZug[2][0])
			{
				TatID = 3;
			}
			if (Rand < PunkteFuerTatUndZug[1][0])
			{
				TatID = 2;
			}
			if (Rand < PunkteFuerTatUndZug[0][0])
			{
				TatID = 1;
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:-1 UmY:-1];
			
			return self;
		}
		bisherigePunkte += GesamtpunkteFuerZug[0];
		
		if (Rand < (bisherigePunkte + GesamtpunkteFuerZug[1]))
		{
			Rand = GesamtpunkteFuerZug[1] * ((float)rand() / RAND_MAX);
			int TatID = 4;
			if (Rand < PunkteFuerTatUndZug[2][1])
			{
				TatID = 3;
			}
			if (Rand < PunkteFuerTatUndZug[1][1])
			{
				TatID = 2;
			}
			if (Rand < PunkteFuerTatUndZug[0][1])
			{
				TatID = 1;
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:-1 UmY:0];
			
			return self;
		}
		bisherigePunkte += GesamtpunkteFuerZug[1];
		
		if (Rand < (bisherigePunkte + GesamtpunkteFuerZug[2]))
		{
			Rand = GesamtpunkteFuerZug[2] * ((float)rand() / RAND_MAX);
			int TatID = 4;
			if (Rand < PunkteFuerTatUndZug[2][2])
			{
				TatID = 3;
			}
			if (Rand < PunkteFuerTatUndZug[1][2])
			{
				TatID = 2;
			}
			if (Rand < PunkteFuerTatUndZug[0][2])
			{
				TatID = 1;
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:-1 UmY:1];
			
			return self;
		}
		bisherigePunkte += GesamtpunkteFuerZug[2];
		
		if (Rand < (bisherigePunkte + GesamtpunkteFuerZug[3]))
		{
			Rand = GesamtpunkteFuerZug[3] * ((float)rand() / RAND_MAX);
			int TatID = 4;
			if (Rand < PunkteFuerTatUndZug[2][3])
			{
				TatID = 3;
			}
			if (Rand < PunkteFuerTatUndZug[1][3])
			{
				TatID = 2;
			}
			if (Rand < PunkteFuerTatUndZug[0][3])
			{
				TatID = 1;
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:0 UmY:-1];
			
			return self;
		}
		bisherigePunkte += GesamtpunkteFuerZug[3];
		
		if (Rand < (bisherigePunkte + GesamtpunkteFuerZug[4]))
		{
			Rand = GesamtpunkteFuerZug[4] * ((float)rand() / RAND_MAX);
			int TatID = 4;
			if (Rand < PunkteFuerTatUndZug[2][4])
			{
				TatID = 3;
			}
			if (Rand < PunkteFuerTatUndZug[1][4])
			{
				TatID = 2;
			}
			if (Rand < PunkteFuerTatUndZug[0][4])
			{
				TatID = 1;
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:0 UmY:0];
			
			return self;
		}
		bisherigePunkte += GesamtpunkteFuerZug[4];
		
		if (Rand < (bisherigePunkte + GesamtpunkteFuerZug[5]))
		{
			Rand = GesamtpunkteFuerZug[5] * ((float)rand() / RAND_MAX);
			int TatID = 4;
			if (Rand < PunkteFuerTatUndZug[2][5])
			{
				TatID = 3;
			}
			if (Rand < PunkteFuerTatUndZug[1][5])
			{
				TatID = 2;
			}
			if (Rand < PunkteFuerTatUndZug[0][5])
			{
				TatID = 1;
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:0 UmY:1];
			
			return self;
		}
		bisherigePunkte += GesamtpunkteFuerZug[5];
		
		if (Rand < (bisherigePunkte + GesamtpunkteFuerZug[6]))
		{
			Rand = GesamtpunkteFuerZug[6] * ((float)rand() / RAND_MAX);
			int TatID = 4;
			if (Rand < PunkteFuerTatUndZug[2][6])
			{
				TatID = 3;
			}
			if (Rand < PunkteFuerTatUndZug[1][6])
			{
				TatID = 2;
			}
			if (Rand < PunkteFuerTatUndZug[0][6])
			{
				TatID = 1;
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:1 UmY:-1];
			
			return self;
		}
		bisherigePunkte += GesamtpunkteFuerZug[6];
		
		if (Rand < (bisherigePunkte + GesamtpunkteFuerZug[7]))
		{
			Rand = GesamtpunkteFuerZug[7] * ((float)rand() / RAND_MAX);
			int TatID = 4;
			if (Rand < PunkteFuerTatUndZug[2][7])
			{
				TatID = 3;
			}
			if (Rand < PunkteFuerTatUndZug[1][7])
			{
				TatID = 2;
			}
			if (Rand < PunkteFuerTatUndZug[0][7])
			{
				TatID = 1;
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:1 UmY:0];
			
			return self;
		}
		
		Rand = GesamtpunkteFuerZug[8] * ((float)rand() / RAND_MAX);
		int TatID = 4;
		if (Rand < PunkteFuerTatUndZug[2][8])
		{
			TatID = 3;
		}
		if (Rand < PunkteFuerTatUndZug[1][8])
		{
			TatID = 2;
		}
		if (Rand < PunkteFuerTatUndZug[0][8])
		{
			TatID = 1;
		}
		
		[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:1 UmY:1];
		
		return self;
	}
	
		//Wenn die Gesamtpunktzahl < 1 ist
	else
	{
		[self Tier:gewaehltesTier willTun:4 mitBewegungUmX:0 UmY:0];
	}

	return self;
}

- (id)Tier:(id)gewaehltesTier willTun:(int)TatID mitBewegungUmX:(int)VerschiebungX UmY:(int)VerschiebungY
{	
		//die verschiedenen TatIDs:
	int Fortpflanzung = 1;
	int Kampf = 2;
	int Weiden = 3;
//	int Warten = 4;
	
	int alterStandortX = [gewaehltesTier StandortX];
	int alterStandortY = [gewaehltesTier StandortY];
		//neuer Standort bleibt vorerst noch alter, denn vielleicht ist Bewegung ungltig (z.B. auf Wasser)
	int neuerStandortX = alterStandortX;
	int neuerStandortY = alterStandortY;
	
	id WunschZielFeld = [[Felder objectAtIndex:alterStandortX+VerschiebungX] objectAtIndex:alterStandortY+VerschiebungY];
	
	id zweitesTier = [WunschZielFeld getTier];

//Bewegung
		//Wenn WunschZielFeld nicht erreicht werden kann
	if ([WunschZielFeld Art] == 4)
	{
		[[[Felder objectAtIndex:alterStandortX] objectAtIndex:alterStandortY] neuesTier:gewaehltesTier];
	}
	else
	{
		if (VerschiebungX != 0 && VerschiebungY != 0)	//Wenn nicht gleich Wasser; wenn nicht gleich keine Bewegung
		{
				//Energie fr Bewegung
			[gewaehltesTier Energieabnahme:2];
				//Bewegung ausfhren
			[gewaehltesTier StandortWechselX:VerschiebungX WechselY:VerschiebungY];
			neuerStandortX = [gewaehltesTier StandortX];
			neuerStandortY = [gewaehltesTier StandortY];
		}

		id neuesFeld = [[Felder objectAtIndex:neuerStandortX] objectAtIndex:neuerStandortY];
		
				//sich vom alten Feld entfernen
		[[[Felder objectAtIndex:alterStandortX] objectAtIndex:alterStandortY] neuesTier:nil];
				//sich beim neuen Feld registrieren
		[neuesFeld neuesTier:gewaehltesTier];
		
	//Aktivitten
		//Bedingungen fr Interaktion mit anderem Tier
		if (zweitesTier != nil && zweitesTier != gewaehltesTier && ![zweitesTier gestorben])
		{
			if (TatID == Kampf)
			{
				if ([gewaehltesTier Groesse]*[gewaehltesTier Geschwindigkeit]*[gewaehltesTier Energiestand] > [zweitesTier Groesse]*[zweitesTier Geschwindigkeit]*[zweitesTier Energiestand])
				{				//gewaehltesTier (Angreifer) gewinnt
					[gewaehltesTier Energieabnahme:0.001*[zweitesTier Groesse]*[zweitesTier Energiestand]*[zweitesTier Geschwindigkeit]];
					[gewaehltesTier Essen:[zweitesTier Energiestand]*0.1];
					[self TierStirbt:zweitesTier an:2];
				}
				else
				{				//gewaehltesTier (Angreifer) verliert
					[zweitesTier Energieabnahme:0.001*[gewaehltesTier Groesse]*[gewaehltesTier Energiestand]*[gewaehltesTier Geschwindigkeit]];
					[zweitesTier Essen:[gewaehltesTier Energiestand]*0.1];
					[self TierStirbt:gewaehltesTier an:3];
					[neuesFeld neuesTier:zweitesTier];
				}
			}
			
			if (TatID == Fortpflanzung)
			{
					//prfen, dass Tiere auch hnlich sind
				if ([gewaehltesTier Groesse]+2 > [zweitesTier Groesse] && [gewaehltesTier Groesse]-2 < [zweitesTier Groesse])
				{
					[Tiere addObject:[[Tier alloc] initMitVater:gewaehltesTier Mutter:zweitesTier]];
					[gewaehltesTier Energieabnahme:2];
					[zweitesTier Energieabnahme:2];
				}
			}
		}
	
		//Weiden
		if (TatID == Weiden)
		{
			if ([neuesFeld Nutzung])
			{
				[gewaehltesTier Essen:[neuesFeld WeideAnziehung]];
			}
		}
	}

	return self;
}
- (id)TierStirbt:(id)TierID an:(int)sender
{
	id myFeld = [[Felder objectAtIndex:[TierID StandortX]] objectAtIndex:[TierID StandortY]];
	[myFeld neuesTier:nil];
/*	if ([Tiere indexOfObjectIdenticalTo:TierID] != NSNotFound)
	{*/				//billige Lsung fr Bug; sollte noch besser werden
		[Tiere removeObjectAtIndex:[Tiere indexOfObjectIdenticalTo:TierID]];
//	}
	[TierID sterbenAn:sender];
	return self;
}

/*- (id)TierStirbt:(int)ID
{
	id gewaehltesTier = [self TierMitID:ID];
	[gewaehltesTier sterben];
	id myFeld = [[Felder objectAtIndex:[gewaehltesTier StandortX]] objectAtIndex:[gewaehltesTier StandortY]];
	[myFeld neuesTier:nil];
	[Tiere removeObjectAtIndex:ID];
	return self;
}
*/

@end
